<template>
    <el-table
        :data="tableRows"
        :border="true"
        :highlight-current-row="true"
        width="100%"
        :row-class-name="setRowClass"
    >
        <el-table-column
            label='Field'
            prop='name'
            width="150"
            :resizable="true"
        >
        </el-table-column>
        <el-table-column
            :label='pendingProfileTypeTitle'
            prop='pending'
            min-width="40%"
            :resizable="true"
        >
            <template v-slot="{ row }">
                <div :id="scrollId(row.id)">
                    <editable-cell  v-if="isEditable(row.id)" :value="value[row.id]" :id="row.id" :config="editableParams[row.id]"
                    @input="changeHandler" :validationPath="pathArr"/>
                    <read-only-cell v-else :value="row.pending" :id="row.id" :config="editableParams[row.id]" :validationPath="pathArr"/>
                </div>
            </template>
        </el-table-column>
        <el-table-column
            label='Diff'
            prop='diff'
            min-width="10%"
            :resizable="true"
        >
            <template v-slot="{ row }">
                <read-only-cell :id="row.id" :value="row.diff" :config="{ type: 'TextDiff', mode: 'status', fromDictionary: fromDictionary(row.id)}"/>
            </template>
        </el-table-column>
        <el-table-column
            label='Published'
            prop='published'
            min-width="40%"
            :resizable="true"
        >
            <template v-slot="{ row }">
                <read-only-cell :id="row.id" :value="row.published" :config="editableParams[row.id]"/>
            </template>
        </el-table-column>
    </el-table>
</template>

<script>
import { SELECT, MULTISELECT } from '@/constants/ui/details';
import ReadOnlyCell from './ReadOnlyCell';
import EditableCell from './EditableCell';

export default {
    components: {
        ReadOnlyCell,
        EditableCell,
    },
    props: {
        /** table id */
        id: {
            type: [String, Number],
            required: false,
        },
        /** table dynamic values in pending column */
        value: {
            type: [Object, Array],
            required: true,
        },
        /** pending and published data */
        diffData: {
            type: Object,
            required: false,
            default: () => {},
        },
        /** title for table */
        headerTitle: {
            type: String,
            required: false,
            default: '',
        },
        /** flag for enabled edit mode */
        editMode: {
            type: Boolean,
            required: false,
            default: false,
        },
        /** editable params for cells */
        editableParams: {
            type: Object,
            required: false,
            default: () => {},
        },
        /** path to associated server params */
        path: {
            type: Object,
            required: false,
            default: () => ({ root: 'rootId', field: 'fieldId' }),
        },
    },
    created() {
        if (this.path && this.path.root) {
            this.pathArr = [this.path.root, ...this.id.split(':')];
        }
    },
    data() {
        return {
            editedValue: { ...this.value },
            pathArr: [],
        };
    },
    computed: {
        haveHeader: (vm) => {
            if (vm.headerTitle === '') {
                return 'no_header';
            }
            return '';
        },
        isEditable: vm => id => vm.editMode && Boolean(vm.editableParams[id]) && vm.$store.getters.isEditableNestedParam(vm.path, id),
        fromDictionary: vm => id => vm.editableParams[id] && [SELECT, MULTISELECT].indexOf(vm.editableParams[id].type) > -1,
        tableRows() {
            const result = [];
            let { published, pending } = this.diffData;
            published = !published ? {} : published;
            pending = !pending ? {} : pending;
            let iterableObj = published;
            if (Object.keys(published).length < Object.keys(pending).length) {
                iterableObj = pending;
            }
            Object.keys(iterableObj).forEach((key) => {
                result.push({
                    name: this.diffData.labels[key],
                    published: published[key],
                    diff: { older: published[key], newer: pending[key] },
                    pending: pending[key],
                    id: key,
                });
            });
            return result;
        },
        pendingProfileTypeTitle: (vm) => {
            const type = vm.$store.getters.pendingProfileType;
            if (type && ['application', 'draft'].indexOf(type) !== -1) {
                return type === 'application' ? 'Ticket in review' : 'Draft';
            }
            return 'Pending';
        },
        scrollId: vm => paramId => ((vm.pathArr.length) ? `${vm.pathArr.join('.')}.${paramId}` : paramId),
    },
    methods: {
        /**
         * Emit event on change cell data
         * @param {Object} eventData - param id and new param value
         */
        changeHandler({ id, value }) {
            this.$emit('edited', {
                tableId: this.id,
                paramId: id,
                oldValue: this.diffData.pending[id],
                newValue: value,
            });
        },
        /**
         * Set row class name (to highlight some rows)
         * @returns {String} class name
         */
        setRowClass({ row }) {
            return this.$store.getters.validationParams([...this.pathArr, row.id]).invalid ? 'is-invalid' : '';
        },
    },
};
</script>
